//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
   AnsiString f_name_in;
   AnsiString f_name_out;
   FILE *f_in, *f_out;
   unsigned char data, bitmask;
   unsigned long i, j;
   unsigned char buf[32];
   unsigned char bufindex;
   unsigned long count;
   unsigned long bytecounter = 4*1024*1024;

   if (!OpenDialog1->Execute())
   {
      return;
   }

   f_name_in = OpenDialog1->FileName;

   if (!SaveDialog1->Execute())
   {
      return;
   }

   f_name_out = SaveDialog1->FileName;

   Edit_Status->Text = "Busy...";
   Application->ProcessMessages();

   f_in = fopen(f_name_in.c_str(), "rb");
   f_out = fopen(f_name_out.c_str(), "wb");

   for(i = 0; i < 0x2C; i++)
   {
      fread(&data, 1, 1, f_in);
   }

   for(count = 0; count < (21846); count++)  // 4 MB Flash, 768000 Bytes/sec, 4000 Hz WAV Samplerate
   {                                         // 4*1024*1024 / 768000 * 4000 = 21845,3
      if(fread(&data, 1, 1, f_in) == 0)
      {
         data = 0x80;
      }
      bufindex = 0;
      bitmask = 0x80;
      for(i = 0; i < 256; i++)
      {
         if( (i!=0) && ((i%8)==0) )
         {
            bufindex++;
            bitmask = 0x80;
         }
         if(data > i)
         {
            buf[bufindex] |= bitmask;
         }
         else
         {
            buf[bufindex] &= (~bitmask);
         }
         bitmask >>= 1;
      }

      for(j = 0; j < 6; j++)
      {
         for(i = 0; i < 32; i++)
         {
            if(bytecounter != 0)
            {
               bytecounter--;
               fprintf(f_out, "%c", buf[i]);
            }
         }
      }
   }

   fclose(f_in);
   fclose(f_out);

   Edit_Status->Text = "Ready.";
   Application->ProcessMessages();
}
//---------------------------------------------------------------------------
